####################
# Zope Army Knife  #
# (c) 2003 Naumen  #
####################
"""
Revision information:
$Id: ZAK.py,v 1.1.1.1 2003/04/10 05:58:40 kvas Exp $

ZAK class
"""

__version__ = '$Revision: 1.1.1.1 $'[11:-2]


from __future__ import nested_scopes

from Globals import DTMLFile, InitializeClass
from Acquisition import aq_inner, aq_parent
from AccessControl import ClassSecurityInfo 
from OFS.SimpleItem import SimpleItem
import sys, traceback


manage_addZAKForm = DTMLFile('dtml/addZAKForm', globals())

def manage_addZAK(self, id, add=None, REQUEST=None):
    "Create a new ZAK and add it to container"
    container = self.Destination()

    if add:
        zak = ZAK(id)
        container._setObject(id, zak)
 
    if REQUEST is not None:
        REQUEST['RESPONSE'].redirect(self.DestinationURL() + '/manage_main')


class ZAK(SimpleItem):
    """Zope Army Knife
    
    Zope arbitrary expression evaluator.
    """
    
    meta_type = 'ZAK (Zope Army Knife)'
    security = ClassSecurityInfo() 
    
    security.declareProtected('Use ZAK',
                              'manage_evaluate') 

    _evaluatorForm = DTMLFile('dtml/evaluatorForm', globals())

    manage_options = SimpleItem.manage_options + \
        ({'label':'Evaluator', 'action':'manage_evaluate'},)


    def __init__(self, id):
        self.id = id

    def manage_evaluate(self, expr=''):
        """Evaluate any expression"""
        if expr:
            result = self.evaluate(expr)
        else:
            result = ''
        
        result = result.replace('&', '&amp;').replace('<', '&lt;')

        return self._evaluatorForm(result=result, expr=expr)

    def evaluate(self, expr):
        expr = expr.replace('\r\n', '\n') + '\n'
        locals = { 'context': self.parent(),
                   'app': self.getPhysicalRoot() }

        try:
            eval(compile(expr, 'code', 'exec'), globals(), locals)
        except:
            type, value, tb = sys.exc_info()
            return ''.join(traceback.format_exception_only(type, value) + \
                            ['\n'] + traceback.format_tb(tb)[1:])

        vars = locals.keys()
        vars.sort()
        return '\n'.join(map(lambda i: str(i) + ' = ' + str(locals[i]), vars))

    def parent(self):
        """return parent (context) of this ZAK"""
        return aq_parent(aq_inner(self))
        

InitializeClass(ZAK)
